var winduid;

apiready = function(){
    setRefreshHeader(); //顶部拉
    render();
};
function render(){
    api.showProgress();
    getData();
    api.parseTapmode();
    api.hideProgress();

	initJpush();
}
function renderStop(){
    api.showProgress();
    getData();
    api.parseTapmode();
    api.hideProgress();

	stopJpush();
}
function setRefreshHeader(){ //顶部拉
    api.setRefreshHeaderInfo({
        visible: true,
        bgColor: '#ccc',
        textColor: '#fff',
        textDown: '下拉刷新...',
        textUp: '松开刷新...',
        showTime: true
    }, function (ret, err) {
        render();
        api.refreshHeaderLoadDone();
    });
}
function getData(){
	var connectionType = api.connectionType;
	if(connectionType == 'none'){
        api.toast({msg: '当前网络连接不通', location: 'middle'})
		return;
	}

    windshopid = $api.getStorage('m_shopid');
	if(!windshopid){
        api.refreshHeaderLoadDone();
		openLogin();
		return;
	}

	var ciphertext = encryptByDES(windshopid, desKey, desIv);

	var param = {
		des_m: ciphertext,
	};

    ajaxRequest(API_URL.bizUcenter, 'get', param, function(ret, err){
        if(ret.status == 0){
			var data = ret.data;
			infoCallBack(data.info);
        }else{
			showTipMsg(ret.msg);
        };
        api.refreshHeaderLoadDone();
    });
}
//订单信息解析
function infoCallBack(data){
	var content = $api.byId('info-content');
	var tpl = $api.byId('info-template').text;
	var tempFn = doT.template(tpl);
	$api.html(content,tempFn(data));
}
function openProduct(pid){
    api.openWin({
        name: 'product',
        url: 'product.html',
        pageParam: {pid: pid}
    });
}
//极光推送
function initJpush(){
	//alert('initJpush');
	//try{
	var ajpush = api.require('ajpush'); //注册
	if (typeof(ajpush) != "undefined"){
		ajpush.init(function(ret){
			if(ret && ret.status){
				//alert(ret.status);
			}else{
				//alert(ret.status);
			}
		});
		//ajpush.getRegistrationId(function(ret) {
		//	var registrationId = ret.id;
			//alert("registrationId:"+registrationId);
		//});
		//应用在前台状态会监听
		ajpush.setListener(
			function(ret) {
				var id = ret.id;
				var title = ret.title;
				var content = ret.content;
				var extra = ret.extra;

				if(typeof extra!='object'){ //如果不是对象，把字符串转变成对象
					var extra = JSON.parse(extra);
				}

				//alert('setListener:extra'+extra+';orderId'+orderId);

				if(extra.type == 'order'){
					var orderId = extra.orderid;
					api.openWin({
						name: 'orderInfo',
						url: 'orderInfo.html',
						pageParam: {orderId: orderId}
					});
				}else if(extra.type == 'insurance'){
					var iid = extra.id;
					api.openWin({
						name: 'insuranceDetail',
						url: 'insuranceDetail.html',
						pageParam: {iid: iid}
					});
				}

			}
		);
		api.addEventListener({name:'pause'}, function(ret,err) { //通知极光推送SDK当前应用退入到后台。
			var ajpush = api.require('ajpush');
			ajpush.onPause();
		});
		api.addEventListener({name:'resume'}, function(ret,err) { //通知极光推送SDK当前应用恢复到前台。
			var ajpush = api.require('ajpush');
			ajpush.onResume();
		});
		//设置别名
		var winduid = $api.getStorage('m_shopid');
		if(winduid){
			var param = {
				alias: 'u_'+winduid,
				tags: ['u_'+winduid]
			};
			ajpush.bindAliasAndTags(param, function(ret) {
				//alert('别名设置成功：'+'u_'+winduid);
			});
		}
		//应用不在前台，点击状态消息后会监听
		api.addEventListener({name:'appintent'}, function(ret,err) {
			if(ret && ret.appParam.ajpush){
				var ajpush = ret.appParam.ajpush;
				var id = ajpush.id;
				var title = ajpush.title;
				var content = ajpush.content;
				var extra = ajpush.extra;

				if(typeof extra!='object'){ //如果不是对象，把字符串转变成对象
					var extra = JSON.parse(extra);
				}
				//alert('appintent:extra'+extra+';orderId'+orderId);

				if(extra.type == 'order'){
					var orderId = extra.orderid;
					api.openWin({
						name: 'orderInfo',
						url: 'orderInfo.html',
						pageParam: {orderId: orderId}
					});
				}else if(extra.type == 'insurance'){
					var iid = extra.id;
					api.openWin({
						name: 'insuranceDetail',
						url: 'insuranceDetail.html',
						pageParam: {iid: iid}
					});
				}
			}
		})
		api.addEventListener({name:'noticeclicked'}, function(ret,err) {
			if(ret && ret.value){
				var ajpush = ret.value;
				var content = ajpush.content;
				var extra = ajpush.extra;

				if(typeof extra!='object'){ //如果不是对象，把字符串转变成对象
					var extra = JSON.parse(extra);
				}
				//alert('noticeclicked:extra'+extra+';orderId'+orderId);

				if(extra.type == 'order'){
					var orderId = extra.orderid;
					api.openWin({
						name: 'orderInfo',
						url: 'orderInfo.html',
						pageParam: {orderId: orderId}
					});
				}else if(extra.type == 'insurance'){
					var iid = extra.id;
					api.openWin({
						name: 'insuranceDetail',
						url: 'insuranceDetail.html',
						pageParam: {iid: iid}
					});
				}
			}
		})
	}
	//}catch(e){
	//	alert(e.message);
	//}
}
function stopJpush(){
	//alert('stopJpush');
	//移除消息监听
	//ajpushObj.removeListener();
	var ajpush = api.require('ajpush');
	ajpush.removeListener();
}
function scan(){
	var FNScanner = api.require('FNScanner');
	FNScanner.openScanner({
	    autorotation: true
	}, function(ret, err){
	    if( ret ){
	        if(ret.eventType == 'success'){
				winduid = $api.getStorage('m_shopid');
				if(!winduid){
					openLogin();
					return;
				}

				var ciphertext = encryptByDES(winduid, desKey, desIv);

				var param = {
					des_m: ciphertext,
				};

				var url = ret.content;

				//ajaxRequest(API_URL.bizOrderEwmConfirm, 'post', param, function(ret, err){
				ajaxRequestFullUrl(url, 'post', param, function(ret2, err){
				    if(ret2.status == 0){
						showSuccess(ret2.msg);

						var orderId = ret2.data.orderId;

						setTimeout(function(){
						    api.openWin({
						        name: 'orderDetail',
						        url: 'orderDetail.html',
						        pageParam: {orderId: orderId}
						    });
						}, 1000);
				    }else{
						showTipMsg(ret2.msg);

						var orderId = ret2.data.orderId;

						setTimeout(function(){
						    api.openWin({
						        name: 'orderDetail',
						        url: 'orderDetail.html',
						        pageParam: {orderId: orderId}
						    });
						}, 1000);
				    };
				});
	        }
	    }else{
	        //alert( JSON.stringify( err ) );
	    }
	});
}
function ajaxRequestFullUrl(url, method, bodyParam, callBack){
    var appKey = 'ee88f88943ad1beg3abfd3ce7aff10d';
    var now = Date.now(); //now = '145455249300'; //方便调试
    //alert(now);
    var token = hex_sha1(appKey + "|" + now) + now;

	bodyParam.token = token;

    //bodyParam = JSON.stringify(bodyParam);
    if(method=='get'){
		var paramStr = $.param(bodyParam);
		url = url + '?' + paramStr;
		bodyParam = '';
    }

    api.ajax({
        url: url,
        method: method,
        cache: false,
        //timeout: 20,
//      headers: {
//          "Content-type": "application/json;charset=UTF-8",
//          "X-APICloud-AppId": appId,
//          "X-APICloud-AppKey": appKey
//      },
        data: {
            values: bodyParam
        }
    }, function (ret, err){
        callBack(ret, err);
    });
}