var winduid;
var winName = 'userProfile';

apiready = function(){
	winduid = $api.getStorage('m_shopid');

    api.parseTapmode();
    render();
    setRefreshHeader(); //顶部拉
};
function render(){
    api.showProgress();
    getData();
    api.parseTapmode();
    api.hideProgress();
}
function setRefreshHeader(){ //顶部拉
    api.setRefreshHeaderInfo({
        visible: true,
        bgColor: '#ccc',
        textColor: '#fff',
        textDown: '下拉刷新...',
        textUp: '松开刷新...',
        showTime: true
    }, function (ret, err) {
        render();
        api.refreshHeaderLoadDone();
    });
}
function getData(){
	var windshopid = $api.getStorage('m_shopid');
	if(!windshopid){
		openLogin();
		return;
	}
	var ciphertext = encryptByDES(windshopid, desKey, desIv);
	var param = {
		des_m: ciphertext,
	};

	ajaxRequest(API_URL.bizProfile, 'get', param, function(ret, err){
        if(ret.status == 0){
			var data = ret.data;

			infoCallBack(data.user); //解析信息
        }else{
			showTipMsg(ret.msg);
        };
    });
}
function infoCallBack(data){
	$('#logo_img').attr('src', data.logo);
	$('#banner_img').attr('src', data.banner);

	var content = $api.byId('info-content');
	var tpl = $api.byId('info-template').text;
	var tempFn = doT.template(tpl);
	$api.html(content,tempFn(data));
}
//保存
function doSubmit(){
    winduid = $api.getStorage('m_shopid');
	if(!winduid){
		openLogin();
		return;
	}

	var ciphertext = encryptByDES(winduid, desKey, desIv);

	//LOGO
    var fileName_logo = $api.byId('fileName_logo').value;
    var fileSize_logo = $api.byId('fileSize_logo').value;
    var fileType_logo = $api.byId('fileType_logo').value;
    var fileData_logo = $api.byId('fileData_logo').value;

	//店招
    var fileName_banner = $api.byId('fileName_banner').value;
    var fileSize_banner = $api.byId('fileSize_banner').value;
    var fileType_banner = $api.byId('fileType_banner').value;
    var fileData_banner = $api.byId('fileData_banner').value;

	//营业执照
    var fileName_license = $api.byId('fileName_license').value;
    var fileSize_license = $api.byId('fileSize_license').value;
    var fileType_license = $api.byId('fileType_license').value;
    var fileData_license = $api.byId('fileData_license').value;

	//其他信息
    var shopname = $api.byId('shopname').value;
    var address = $api.byId('address').value;
    var intro = $api.byId('intro').value;

	var param = {
		des_m: ciphertext,
		shopname: shopname,
		address: address,
		intro: intro,
	};
	if(fileName_logo){
		param.fileName_logo = fileName_logo;
		param.fileSize_logo = fileSize_logo;
		param.fileType_logo = fileType_logo;
		param.fileData_logo = fileData_logo;
	}
	if(fileName_banner){
		param.fileName_banner = fileName_banner;
		param.fileSize_banner = fileSize_banner;
		param.fileType_banner = fileType_banner;
		param.fileData_banner = fileData_banner;
	}
	if(fileName_license){
		param.fileName_license = fileName_license;
		param.fileSize_license = fileSize_license;
		param.fileType_license = fileType_license;
		param.fileData_license = fileData_license;
	}

	ajaxRequest(API_URL.doBizProfile, 'post', param, function(ret, err){
        if(ret.status == 0){
			showSuccess(ret.msg);

			setTimeout(function(){
				api.execScript({
					name: 'main',
					frameName: 'main-con',
					script: 'render();'
				});
				api.closeWin();
			}, 1000);
        }else{
			showTipMsg(ret.msg);
        };
    });
}

$('.J_h5upload').on("click", function(){
	var objid = $(this).attr('id');
	var isClip = $(this).attr('data-isClip');
	api.actionSheet({
        //title: '上传',
        //cancelTitle: '取消',
        buttons: ['拍照','从相册选择']
	},function(ret,err){
		if(ret.buttonIndex == 1){
			getCamera(objid, isClip);
		}else if(ret.buttonIndex == 2){
			//getMedia(objid, isClip);
			getPicture(objid, isClip);
			//var systemType = api.systemType;
			//if(systemType == 'android'){
			//}else{

			//}
		}else{

		}
	});
});

//在Frame中打开裁剪页面
function openImageClip(path, objid){
	api.openFrame({
		name : 'imageClip',
		url : 'imageClip.html',
		pageParam: {path:path, winName:winName, objid:objid},
		rect : {
			x : 0,
			y : 0,
			w : api.winWidth,
			h : api.winHeight
		},
		bounces : false,
		opaque : false,
		bgColor : 'rgba(0,0,0,0.0)'
	});
}
function getCamera(objid, isClip){
	api.getPicture({
		sourceType: 'camera',
        encodingType: "jpg",
        mediaValue: "pic",
        allowEdit: false
	}, function(ret, err){
		if (ret) { //拍照成功后
			//var systemType = api.systemType;
			//if(systemType == 'android'){
			var filePath = ret.data;
			if(filePath){
				if(isClip==1){
					openImageClip(filePath, objid); //选择照片后，在Frame中打开裁剪页面
				}else{
					var fileName = filePath.substring(filePath.lastIndexOf('/')+1);
					var fileType = 'jpg';
					var fileSize = '100';
					h5uploadOne(objid, filePath, fileName, fileType, fileSize);
				}
			}
// 			}else{
// 				var filePath = ret.data;
// 				var fileType = 'jpg';
// 				var fileSize = '100';
// 				var fileName = filePath.substring(filePath.lastIndexOf('/')+1);
// 				api.execScript({
// 					script: 'h5uploadOne("'+filePath+'","'+fileName+'","'+fileType+'","'+fileSize+'");'
// 				});
// 			}
		} else{
			api.alert({msg:err.msg});
		}
	});
}
function getPicture(objid, isClip){
	api.getPicture({
        sourceType: 'library',
        encodingType: 'jpg',
        mediaValue: 'pic',
        destinationType: 'url',
        allowEdit: false,
        quality: 100,
        //targetWidth:100,
        //targetHeight:100,
        saveToPhotoAlbum: false
    }, function(ret, err){
		if (ret) { //拍照成功后
			//var systemType = api.systemType;
			//if(systemType == 'android'){
			var filePath = ret.data;
			if(filePath){
				if(isClip==1){
					openImageClip(filePath, objid); //选择照片后，在Frame中打开裁剪页面
				}else{
					var fileName = filePath.substring(filePath.lastIndexOf('/')+1);
					var fileType = 'jpg';
					var fileSize = '100';
					h5uploadOne(objid, filePath, fileName, fileType, fileSize);
				}
			}
// 			}else{
// 				var filePath = ret.data;
// 				var fileType = 'jpg';
// 				var fileSize = '100';
// 				var fileName = filePath.substring(filePath.lastIndexOf('/')+1);
// 				api.execScript({
// 					script: 'h5uploadOne("'+filePath+'","'+fileName+'","'+fileType+'","'+fileSize+'");'
// 				});
// 			}
		} else{
			api.alert({msg:err.msg});
		}
	});
}
//在Frame中打开裁剪页面(供直接拍照使用)
function openImageClip(path, objid){
	api.openFrame({
		name : 'imageClip',
		url : 'imageClip.html',
		pageParam: {path:path, winName:winName, objid:objid},
		rect : {
			x : 0,
			y : 0,
			w : api.winWidth,
			h : api.winHeight
		},
		bounces : false,
		opaque : false,
		bgColor : 'rgba(0,0,0,0.0)'
	});
}
function h5uploadOne(objid, filePath, fileName, fileType, fileSize){
// 	alert('objid是：'+objid);
// 	alert('图片路径：'+filePath);
// 	alert('图片名称：'+fileName);
	var parent = $('#'+objid);
	//alert(parent);
	//var lr = parent.find('.lr');
	//var imgObj = parent.next();
	var imgObj = parent.find('img');
	imgObj.css('display', 'block');
	//alert(imgObj.attr('class'));
	//var lr = $(this).parent();
	lrz(filePath, {width: 240, quality:0.9}, function(results){ //使用lrz.mobile.min.js直接压缩
    	//console.log(results);
		var file = results.origin;

		//alert('图片base64长度：'+results.base64.length);
		//alert("results.base64:"+results.base64);
		//alert(file.name);
 		//alert(file.type);
 		//alert(file.size);

		parent.find('.fileName').val(fileName);
		parent.find('.fileType').val(fileType);
		parent.find('.fileSize').val(fileSize);
		parent.find('.fileData').val(results.base64);

		//parent.find('.lr-img').attr("src",results.base64);

		//lr.removeClass('waiting');
		//lr.addClass('ready');
		imgObj.attr("src", results.base64);

	});
}